charmrun FT: Fix wrong output in ssh script during recovery from node crash
[charm.git] / build
bloba9ae53c04fc176afb7ce1664bb67bdd1749389e0
1 #!/bin/sh
3 # Silly shorthand, used for source reorganization
4 srcbase="$(cd $(dirname $0)/src/; pwd)"
5 src="$srcbase/arch/"
7 more=0
9 syntax() {
10 echo ''
11 echo 'Usage: build <target> <version> <options> [charmc-options ...]'
12 echo ''
13 echo '<targets>: converse charm++ LIBS AMPI FEM bigemulator pose msa'
14 echo '<targets>: doc ps-doc pdf-doc html-doc'
15 if test $more = 1
16 then
17 echo ''
18 echo ' charm++ compile Charm++ core only'
19 echo ' AMPI compile Adaptive MPI on top of Charm++'
20 echo ' FEM compile FEM framework'
21 echo ' LIBS compile additional parallel libraries with Charm++ core'
22 echo ' bigemulator build additional BigSim libraries'
23 echo ' pose build POSE parallel discrete event simulator'
24 echo ' msa build Multiphase Shared Arrays(MSA) library'
25 echo ' Tau build the TAU tracing library for generating TAU performance data'
26 echo ' ChaNGa compile Charm++ core and necessary libraries for ChaNGa'
27 echo ' everylb compile EveryLB suite of load balancing strategies'
28 echo ''
30 echo '<versions>: '
31 ( cd $src ; ls -1 | egrep -v '(^shmem$)|(^mpi$)|(^sim$)|(^net(lrts)?$)|(^multicore$)|(^util$)|(^common$)|(^uth$)|(^conv-mach-fix.sh$)|(^win32$)|(^win64$)|(^lapi$)|(^cell$)|(^(gemini_)?gni$)|(^pami(lrts)?$)|(^verbs$)|(^template$)|(^cuda$)' | pr -3 -t )
32 echo ''
33 echo '<options>: compiler and platform specific options'
34 echo 'icc iccstatic xlc xlc64 gcc clang craycc pgcc pathscale cc cc64 mpcc ecc gcc64 gcc3 mpcc32 mpcc64 mpicxx'
35 echo 'help smp gm tcp scyld clustermatic bigemulator ooc syncft mlogft causalft'
36 echo 'papi pthreads lam'
37 echo '--incdir --libdir --basedir --build-shared --destination --suffix -j'
38 if test $more = 1
39 then
40 echo ''
41 echo 'For platform specific options, use help option:'
42 echo ' help platform specific help, e.g. ./build charm++ net-linux-x86_64 help'
43 echo ''
44 echo 'Choose a compiler (only one option is allowed from this section):'
45 echo ' icc, iccstatic Intel compilers (default or static linking)'
46 echo ' xlc, xlc64 IBM XL compilers (with 64-bit option on architectures with 32-bit modes)'
47 echo ' gcc GNU compiler collection (on platforms where the default differs)'
48 echo ' clang Clang C/C++ compiler'
49 echo ' craycc Cray compilers'
50 echo ' pgcc Portland Group compilers'
51 echo ' pathscale Pathscale compiler suite'
52 echo ' cc, cc64 For Sun WorkShop C++ 32/64 bit compilers'
53 echo ' mpcc SUN Solaris C++ compiler for MPI'
54 echo ' ecc Intel C/C++ compiler for Linux IA64 (Itanium)'
55 echo ' gcc3 GNU GCC/G++ version 3'
56 echo ''
57 echo 'Choose an alternative fortran compiler (only one option is allowed from this section):'
58 echo ' g95 G95 at http://ww.g95.org'
59 echo " pgf90 Portland Group Fortran compiler"
60 echo ' ifort Intel Fortran compiler'
61 echo ''
62 echo 'Platform specific options (choose multiple if apply):'
63 echo ' smp support for SMP, multithreaded charm on each node'
64 echo ' ibverbs use Infiniband Verbs for communication (only for net-linux-x86_64; prefer verbs-*)'
65 echo ' lam Use LAM MPI'
66 echo ' mpt use SGI Message Passing Toolkit (only for mpi version)'
67 echo ' gm use Myrinet for communication'
68 echo ' tcp use TCP sockets for communication (only for net version)'
69 echo ' scyld compile for Scyld Beowulf cluster based on bproc'
70 echo ' clustermatic compile for Clustermatic (support version 3 and 4) '
71 echo ' pthreads compile with pthreads Converse threads'
72 echo ''
73 echo 'Advanced options:'
74 echo ' bigemulator compile for BigSim simulator'
75 echo ' ooc compile with out of core support'
76 echo ' syncft compile with Charm++ fault tolerance support'
77 echo ' mlogft compile with Charm++ message logging fault tolerance support'
78 echo ' papi compile with PAPI performance counter support (if any)'
79 echo ''
80 echo "Charm++ dynamic libraries:"
81 echo " --no-build-shared don't build Charm++'s shared libraries (default)"
82 echo " --build-shared build Charm++ dynamic libraries (.so) "
83 echo ''
84 echo 'Enable/disable features:'
85 $srcbase/scripts/configure --help | grep enable-
86 $srcbase/scripts/configure --help | grep with-
87 echo " --with-production build Charm++ with all optimizations for maximum performance, and disabling all above features"
88 echo ''
89 echo 'Miscellaneous options:'
90 echo ' --incdir=DIR specify additional include path for compiler'
91 echo ' --libdir=DIR specify additional lib path for compiler'
92 echo ' --basedir=DIR shortcut for the above two - DIR/include and DIR/lib'
93 echo ' -j[N] parallel make, N is the number of paralle make jobs'
94 echo " --with-romio build AMPI with ROMIO library"
95 echo " --with-lbtime-type specify real type for the load balancing timers"
96 echo " --destination=DIR build Charm++ inside DIR, by default the destination is <version>"
97 echo " --suffix=DIR append DIR to the destination directory of the Charm++ build"
98 echo " --tau-makefile=FILE Specify which TAU stub makefile to use"
100 echo ''
101 echo '<charmc-options>: normal compiler options e.g. -g -optimize -save -verbose'
102 if test $more = 1
103 then
104 echo ''
105 echo 'Examples:'
106 echo "1. display all supported options for net-linux-x86_64 using 'help':"
107 echo ' ./build charm++ net-linux-x86_64 help'
108 echo '2. compile Charm++ on Linux with all available tuning:'
109 echo ' ./build charm++ net-linux-x86_64 --with-production'
110 echo '3. compile Charm++ for Linux (32bit) clustermatic Beowulf cluster with Intel compiler and optimizations:'
111 echo ' ./build charm++ net-linux clustermatic icc -optimize'
112 echo '4. compile Charm++ for IA64 Linux cluster with MPICH-GM:'
113 echo ' ./build charm++ mpi-linux-ia64 gm -optimize'
114 echo '5. compile Charm++ for Windows with VC++ (Cygwin required):'
115 echo ' ./build charm++ net-win32 -optimize'
116 echo '6. compile on IBM SP with MPI using parallel gmake, 4 jobs simultaneously:'
117 echo ' MAKE=gmake ./build charm++ mpi-sp -j4 -optimize # sh'
118 echo ' setenv MAKE gmake; ./build charm++ mpi-sp -j4 -optimize # csh'
119 echo '7. compile Charm++ with MPI that is installed at /usr/local/mpich:'
120 echo ' ./build charm++ mpi-linux --incdir /usr/local/mpich/include --libdir /usr/local/mpich/lib -optimize'
121 echo ' or in short,'
122 echo ' ./build charm++ mpi-linux --basedir /usr/local/mpich -optimize'
123 echo ' ./build Tau --tau-makefile=/usr/local/packages/TAU/x86_64/lib/Makefile.tau-mpi'
124 echo ''
125 echo 'Note: This script:'
126 echo ' 1. Creates directories <destination> and <destination>/tmp'
127 echo ' 2. Copies src/scripts/Makefile into <destination>/tmp'
128 echo ' 3. Does a "make basics" in <destination>/tmp.'
129 echo ' 3. Does a "make -jN <target> <version> OPTS=<charmc-options>" in <destination>/tmp.'
130 echo "That's all build does. The rest is handled by the Makefile."
131 echo ''
132 echo 'Thank you for using Charm++, please send questions or comments to '
133 echo 'Parallel Programming Lab at University of Illinois at Urbana-Champaign'
134 echo '(email: charm@cs.illinois.edu).'
136 else
137 echo ''
138 echo "To get more detailed help, run ./build --help"
142 Echo() {
143 [ "x$QUIET" = "x--quiet" ] || echo $*
146 printOption() {
147 for prefix in cc conv-mach
149 str="Supported compilers:"
150 [ "$prefix" = "conv-mach" ] && str="Supported options:"
151 opts=""
152 for dir in $OPT_DIRS
154 # echo "Checking for $prefix in $dir"
155 files=`cd $dir; ls $prefix-*.h 2>/dev/null`
156 opts="$opts "`echo $files | sed 's/'$prefix'-\([^.]*\).h/\1/g'`
157 done
158 tmp=.tmp.$$
159 rm -f $tmp; touch $tmp
160 for o in $opts
162 echo $o >> $tmp
163 done
164 opts=`sort $tmp | uniq`
165 rm -f $tmp
166 echo $str $opts
167 done
168 exit 1
171 CheckDir() {
172 for d in $*
174 if test ! -d $d
175 then
176 echo Error: cannot find $d!
177 exit 1
179 done
182 TestIfCompiler() {
183 for dir in $OPT_DIRS
185 [ -f $dir/cc-$1.sh ] && return 1
186 done
187 return 0
190 TestIfOption() {
191 for dir in $OPT_DIRS
193 [ -f $dir/conv-mach-$1.h ] && return 1
194 done
196 echo "Error> option: $1 is not supported in this version!";
197 printOption
201 # start
203 BUILD_CUDA=0
204 MAKEOPTS=""
205 OPTS=""
206 BOPTS=""
207 MORE=""
208 COMPILER=""
209 BASEDIR=
210 LIBDIR=
211 INCDIR=
212 ARCH=
213 BUILD_SHARED="" # default no shared lib
214 WITH_ROMIO=
215 WITH_PRODUCTION=
216 BUILD_EMULATOR=0
217 DESTINATION=""
218 DESTINATION_SUFFIX=""
219 TAU_MAKEFILE=""
220 QUIET=""
222 [ "$1" = '--help' -o "$1" = '-h' ] && more=1 && syntax | ( less || more ) && exit 1
223 [ $# -lt 2 ] && ./smart-build.pl && exit 1
224 PROGRAM=$1
225 shift
227 # find longest prefix of version argument that exists as a directory in $src
228 VERSION=$1
229 VERSOPTS=""
230 testversion=""
231 oldifs=$IFS
232 IFS=-
233 for w in $1; do
234 IFS=$oldifs
235 if [ -z "$testversion" ]; then
236 testversion=$w
237 else
238 testversion="$testversion-$w"
240 if [ -d $src/$testversion ]; then
241 VERSION=$testversion
242 VERSOPTS=""
243 else
244 VERSOPTS="$VERSOPTS $w"
246 done
247 if [ $VERSION = $1 ]; then VERSOPTS=""; fi
249 BASEVERSION=$VERSION;
250 if test -f $src/$BASEVERSION/vdir_link
251 then
252 BASEVERSION=`cat $src/$BASEVERSION/vdir_link`
254 ARCH=`echo $BASEVERSION | sed -e 's@-.*@@'`
255 shift
257 #echo $src
258 #echo $BASEVERSION
259 #echo $ARCH
261 OPT_DIRS="$src/$BASEVERSION $src/$ARCH $src/common"
263 # process remainder of version argument as options, copied from below
264 for w in $VERSOPTS; do
265 # This has to be a build-time option (like "smp", "gcc3", or "kcc")
266 TestIfCompiler $w
267 if [ $? -eq 1 ]
268 then
269 # It specifies a compiler:
270 if [ ! -z "$COMPILER" ]
271 then
272 echo "Error> Tried to specify two compilers: $COMPILER and $w"
273 printOption
275 COMPILER=$w
276 else
277 # It specifies some other option:
278 TestIfOption $w
279 BOPTS="$BOPTS $w"
280 [ $w = "bigemulator" ] && BUILD_EMULATOR=1
281 [ $w = "bigsim" ] && BUILD_EMULATOR=1
282 [ $w = "cuda" ] && BUILD_CUDA=1
284 done
286 while [ ! $# -eq 0 ]
288 case "$1" in
289 "--basedir")
290 shift;
291 for dir in $1
293 CheckDir $dir/include $dir/lib
294 LIBDIR="$LIBDIR -L$dir/lib";
295 INCDIR="$INCDIR -I$dir/include"
296 done
297 shift
299 --basedir=*)
300 basedir=`echo $1 | awk -F= '{print $2}'`
301 for dir in $basedir
303 CheckDir $dir/include $dir/lib
304 LIBDIR="$LIBDIR -L$dir/lib";
305 INCDIR="$INCDIR -I$dir/include"
306 done
307 shift
309 "--libdir")
310 shift; CheckDir $1
311 for dir in $1
313 LIBDIR="$LIBDIR -L$dir";
314 done
315 shift
317 --libdir=*)
318 libdir=`echo $1 | awk -F= '{print $2}'`
319 CheckDir $libdir
320 for dir in $libdir
322 LIBDIR="$LIBDIR -L$dir";
323 done
324 shift
326 "--incdir")
327 shift; CheckDir $1
328 for dir in $1
330 INCDIR="$INCDIR -I$dir";
331 done
332 shift
334 --incdir=*)
335 incdir=`echo $1 | awk -F= '{print $2}'`
336 CheckDir $incdir
337 for dir in $incdir
339 INCDIR="$INCDIR -I$dir";
340 done
341 shift
343 --no-build-shared|--no-shared)
344 #BUILD_SHARED="-no-build-shared";
345 shift
347 --build-shared)
348 BUILD_SHARED="-build-shared";
349 shift
351 --with-romio)
352 WITH_ROMIO="true"; shift
354 --with-production)
355 WITH_PRODUCTION="true"
356 shift
358 --with-*)
359 CONFIG_OPTS="$CONFIG_OPTS $1"
360 shift
362 --without-*)
363 CONFIG_OPTS="$CONFIG_OPTS $1"
364 shift
366 --destination)
367 shift
368 DESTINATION="$1"
369 shift
371 --destination=*)
372 DESTINATION="`echo $1 | awk -F= '{print $2}'`"
373 shift
375 --suffix)
376 shift
377 DESTINATION_SUFFIX="$1"
378 shift
380 --suffix=*)
381 DESTINATION_SUFFIX="`echo $1 | awk -F= '{print $2}'`"
382 shift
384 --tau-makefile)
385 TAU_MAKEFILE=$1
386 shift
388 --tau-makefile=*)
389 TAU_MAKEFILE=`echo $1 | awk -F= '{print $2}'`
390 shift
392 --quiet)
393 MAKEOPTS="$MAKEOPTS --quiet"
394 QUIET="--quiet"
395 shift;
397 --enable-tracing|--enable-tracing=*)
398 CONFIG_OPTS="$CONFIG_OPTS $1"
399 ENABLE_TRACING=yes
400 shift
402 --enable-*)
403 CONFIG_OPTS="$CONFIG_OPTS $1"
404 shift
406 --disable-*)
407 CONFIG_OPTS="$CONFIG_OPTS $1"
408 shift
410 -j*)
411 PMAKENUM=`echo $1 | awk -Fj '{print $2}'`
412 MAKEOPTS="$MAKEOPTS -j $PMAKENUM"
413 shift;
415 -*)
416 # We hit a real compiler option (like -g, or -Dfoo),
417 # so just copy over all remaining options
418 while [ ! $# -eq 0 ]
420 OPTS="$OPTS $1"; shift
421 done
423 "help")
424 printOption
427 # This has to be a build-time option (like "smp", "gcc3", or "kcc")
428 TestIfCompiler $1
429 if [ $? -eq 1 ]
430 then
431 # It specifies a compiler:
432 if [ ! -z "$COMPILER" ]
433 then
434 echo "Error> Tried to specify two compilers: $COMPILER and $1"
435 printOption
437 COMPILER=$1
438 else
439 # It specifies some other option:
440 TestIfOption $1
441 BOPTS="$BOPTS $1"
442 [ $1 = "bigemulator" ] && BUILD_EMULATOR=1
443 [ $1 = "bigsim" ] && BUILD_EMULATOR=1
444 [ $1 = "cuda" ] && BUILD_CUDA=1
446 shift
448 esac
449 done
451 if [ $BUILD_CUDA -eq 1 ]; then
452 echo "checking for CUDA toolkit directory"
453 CUDA_CANDIDATE_DIRS="$CUDATOOLKIT_HOME /usr/local/cuda /usr/lib/nvidia-cuda-toolkit"
454 for dir in $CUDA_CANDIDATE_DIRS; do
455 if test -d "$dir"; then
456 CUDA_DIR="$dir"
457 HAVE_CUDA="yes"
458 echo "CUDA_DIR=$CUDA_DIR"
459 break
461 done
464 [ "x$VERSION" = "x" ] && syntax && exit 1
466 if test -n "$WITH_PRODUCTION" -a $BUILD_EMULATOR -eq 1 -a -z "$ENABLE_TRACING"
467 then
468 echo "Error: bigemulator requires tracing modules, --with-production must be used with --enable-tracing"
469 exit 1
472 if [ -z "$MAKE" ]
473 then
474 # prefer gmake
475 MAKE=`which gmake 2>/dev/null`
476 [ -z "$MAKE" -o ! -x "$MAKE" ] && MAKE='make'
479 if [ ! -f $src/$BASEVERSION/conv-mach.h ]
480 then
481 if [ "x_$BASEVERSION" = "x_net-rs6k" ]
482 then
483 echo "Error> build net-aix-ppc instead of net-rs6k!"
484 else
485 echo "Error> build can not find arch: $BASEVERSION!"
487 exit 1
490 #generate VERSION name combining all the build-time options.
491 if [ -n "$BOPTS" -o -n "$COMPILER" ]
492 then
493 echo "Selected Compiler: $COMPILER"
494 echo "Selected Options: $BOPTS"
495 SORTED=`echo $BOPTS | awk '{ for (i = 1; i <= NF; ++i) print $i }' | sort`
496 BOPTS_WITHCOMPILER=`echo $SORTED $COMPILER`
497 for i in $BOPTS_WITHCOMPILER
499 VERSION=$VERSION-$i
500 done
503 #echo "|$DESTINATION|$DESTINATION_SUFFIX|"
505 if [ -z "$DESTINATION" ]
506 then
507 DESTINATION="$VERSION"
510 if [ -n "$DESTINATION_SUFFIX" ]
511 then
512 DESTINATION="$DESTINATION-$DESTINATION_SUFFIX"
515 [ -d $DESTINATION ] || Echo "Creating dir: $DESTINATION"
516 [ -d $DESTINATION ] || mkdir $DESTINATION
517 [ -d $DESTINATION/tmp ] || Echo "Creating dir: $DESTINATION/tmp"
518 [ -d $DESTINATION/tmp ] || mkdir $DESTINATION/tmp
520 Echo "Copying src/scripts/Makefile to $DESTINATION/tmp"
521 rm -f $DESTINATION/tmp/Makefile
522 rm -f $DESTINATION/tmp/Make.depends
523 rm -f $DESTINATION/tmp/Make.cidepends
524 rm -f $DESTINATION/tmp/Make.lb
525 rm -f $DESTINATION/tmp/Make.machine
526 rm -f $DESTINATION/tmp/Make.extlib
529 # Create the bin, lib, include, etc. links:
530 WINNAME=`echo $VERSION | awk -F- '{print $2}'`
531 if [ "x_$WINNAME" = "x_win32" -o "x_$WINNAME" = "x_win64" ]
532 then
533 #Win32/64 version needs special compilers and *copied* (not linked)
534 # source files.
535 cp $src/win32/system_ln $DESTINATION/tmp
536 cp $src/win32/unistd.h $DESTINATION/tmp
537 echo "Compiling createlink.cpp ..."
538 (cd $src/win32; ../$WINNAME/unix2nt_cc -c createlink.cpp -o createlink.o -D_WIN32_WINNT=0x0500; ../$WINNAME/unix2nt_cc createlink.o)
540 if test ! -x $src/win32/createlink.exe
541 then
542 echo "VC++ is not properly installed!"
543 exit 1
545 chmod +x $DESTINATION/tmp/system_ln
546 cp $src/win32/gathertree.local $DESTINATION/tmp
547 cp $src/win32/gatherflat.local $DESTINATION/tmp
548 else
549 cat > $DESTINATION/tmp/system_ln <<EOF
550 #!/bin/sh
551 ln -f -s \$@
553 chmod +x $DESTINATION/tmp/system_ln
554 for newdir in `echo bin lib lib_so include tmp`
556 Echo "Soft-linking over $newdir"
557 if [ -r $newdir ]
558 then
559 rm -fr $newdir || exit 1
561 $DESTINATION/tmp/system_ln $DESTINATION/$newdir $newdir
562 done
563 rm -f VERSION
564 $DESTINATION/tmp/system_ln $DESTINATION/include/VERSION VERSION
567 $DESTINATION/tmp/system_ln "$srcbase/scripts/Make.depends" $DESTINATION/tmp/Make.depends
568 $DESTINATION/tmp/system_ln "$srcbase/scripts/Make.cidepends" $DESTINATION/tmp/Make.cidepends
569 if test -f "$srcbase/ck-ldb/Make.lb"
570 then
571 $DESTINATION/tmp/system_ln "$srcbase/ck-ldb/Make.lb" $DESTINATION/tmp/Make.lb
572 else
573 touch $DESTINATION/tmp/Make.lb
575 $DESTINATION/tmp/system_ln "$srcbase/scripts/Makefile" $DESTINATION/tmp/Makefile
576 $DESTINATION/tmp/system_ln "$srcbase/scripts/Make.tau" $DESTINATION/tmp/Make.tau
577 touch $DESTINATION/tmp/Makefile.machine
578 touch $DESTINATION/tmp/Make.extlib
580 ConvUsr="$DESTINATION/tmp/conv-mach-pre.sh"
581 Echo "Generating $ConvUsr"
582 echo > $ConvUsr
583 if test -n "$LIBDIR"
584 then
585 echo 'USER_OPTS_LD="$USER_OPTS_LD '$LIBDIR'"' >> $ConvUsr
586 echo 'USER_OPTS_LDXX="$USER_OPTS_LDXX '$LIBDIR'"' >> $ConvUsr
588 if test -n "$INCDIR"
589 then
590 echo 'USER_OPTS_CC="$USER_OPTS_CC '$INCDIR'"' >> $ConvUsr
591 echo 'USER_OPTS_CXX="$USER_OPTS_CXX '$INCDIR'"' >> $ConvUsr
593 chmod +x $ConvUsr
595 # Create conv-mach-opt headers with special build-time options
596 ConvHeader="$DESTINATION/tmp/conv-mach-opt.h"
597 ConvSh="$DESTINATION/tmp/conv-mach-opt.sh"
598 if [ ! -f $ConvSh -o ! -f $ConvHeader ]
599 then
600 Echo "Generating $ConvHeader, conv-mach-opt.sh"
601 echo '/* Build-time options header, automatically generated by charm/build*/'> $ConvHeader
602 echo '# Built-time options header, automatically generated by charm/build'> $ConvSh
603 echo '[ -z "$CHARMINC" ] && CHARMINC="."' >> $ConvSh
605 if test -n "$COMPILER"
606 then
607 i="$COMPILER"
608 echo '#include "'cc-$i.h'"' >> $ConvHeader
609 echo '. $CHARMINC/'"cc-$i.sh" >> $ConvSh
611 if test -n "$BOPTS"
612 then
613 # pxshm+smp note: When combining the 'smp' and 'pxshm' directives, it is
614 # important that they be included in $ConvHeader in that
615 # exact order. See bug #717.
616 TMP=""
617 HAS_PXSHM=0
618 HAS_SMP=0
619 for i in $BOPTS; do
620 if [ "$i" = "smp" ]; then
621 HAS_SMP=1
622 elif [ "$i" = "pxshm" ]; then
623 HAS_PXSHM=1
624 else
625 TMP="$TMP $i"
627 done
628 if [ $HAS_PXSHM -eq 1 ]; then
629 TMP="pxshm $TMP"
631 if [ $HAS_SMP -eq 1 ]; then
632 TMP="smp $TMP"
635 BOPTS=$TMP
636 for i in $BOPTS
638 echo '#include "'conv-mach-$i.h'"' >> $ConvHeader
639 if [ $BUILD_CUDA -eq 1 ]; then
640 echo 'CUDA_DIR="'$CUDA_DIR'"'>>$ConvSh
642 echo '. $CHARMINC/'"conv-mach-$i.sh" >> $ConvSh
643 done
646 if test "$BUILD_SHARED" = "-build-shared"
647 then
648 echo "CMK_NO_BUILD_SHARED=false" >> $ConvSh
649 else
650 echo "CMK_NO_BUILD_SHARED=true" >> $ConvSh
653 if test -n "$WITH_ROMIO"
654 then
655 echo "CMK_AMPI_WITH_ROMIO=\"true\"" >> $ConvSh
658 if test -n "$WITH_PRODUCTION"
659 then
660 echo '#define CMK_OPTIMIZE 1' >> $ConvHeader
661 # Prepend optimize so that an explicit -no-optimize still works
662 OPTS="-optimize -production $OPTS"
663 CONFIG_OPTS="--disable-controlpoint --disable-tracing --disable-tracing-commthread --disable-charmdebug --disable-replay --disable-error-checking --disable-stats $CONFIG_OPTS"
666 # build with Tau
667 WITH_TAU=0
668 if [ "$PROGRAM" = "Tau" ]
669 then
670 Echo "TAU>>>> makefile config option: $TAU_MAKEFILE"
671 if [ -n "$TAU_MAKEFILE" -a -f $TAU_MAKEFILE ]
672 then
673 #Setting up TAU trace library:
674 Echo "TAU>>>> configuring with this TAU makefile: $TAU_MAKEFILE"
676 WITH_TAU=1
677 else
678 Echo "TAU>>>> ERROR could not find Makefile: $TAU_MAKEFILE, ignored"
679 TAU_MAKEFILE=""
683 if test $WITH_TAU -eq 1
684 then
685 [ -z "$TAU_MAKEFILE" ] && TAU_MAKEFILE="Make.tau"
686 SED_CHARMC="s@TAU_MAKEFILE=\(.*\)@TAU_MAKEFILE=$TAU_MAKEFILE@"
688 sed -e $SED_CHARMC $srcbase/scripts/Makefile > .Makefile.$$ && cp .Makefile.$$ $srcbase/scripts/Makefile && rm -f .Makefile.$$
689 sed -e $SED_CHARMC $srcbase/scripts/charmc > .charmc.$$ && cp .charmc.$$ $srcbase/scripts/charmc && rm -f .charmc.$$
691 echo "#define CMK_WITH_TAU 1" >> $ConvHeader
692 echo "#define pthread_create tau_pthread_create" >> $ConvHeader
693 echo "#define pthread_exit tau_pthread_exit" >> $ConvHeader
695 echo "CMK_WITH_TAU=\"true\"" >> $ConvSh
698 if [ "$PROGRAM" = "ChaNGa" ]
699 then
700 #Setting lbuserdata when the build is ChaNGa
701 CONFIG_OPTS="--enable-lbuserdata $CONFIG_OPTS"
704 echo $BASEVERSION > $DESTINATION/tmp/.vdir
705 echo $BASEVERSION | sed -e 's@-.*@@' > $DESTINATION/tmp/.gdir
707 if test $BUILD_EMULATOR = 1
708 then
709 PROGRAM="$PROGRAM bigsim"
710 # CONFIG_OPTS="--disable-charmdebug $CONFIG_OPTS"
713 printError()
715 Echo "-------------------------------------------------"
716 Echo "Charm++ NOT BUILT. Either cd into $DESTINATION/tmp and try"
717 Echo "to resolve the problems yourself, visit"
718 Echo " http://charm.cs.illinois.edu/"
719 Echo "for more information. Otherwise, email the developers at charm@cs.illinois.edu"
720 exit $MAKEEXIT
723 echo 'BUILDOPTS="'$OPTS'"' >> $ConvSh
724 echo "SRCBASE=$srcbase" > $DESTINATION/tmp/charmpath.mk
726 Echo "Performing '$MAKE $MAKEOPTS basics OPTS="$OPTS" QUIET="$QUIET" CONFIG_OPTS="$CONFIG_OPTS"' in $DESTINATION/tmp"
727 cd $DESTINATION/tmp
728 echo "CONFIG_OPTS=\"$CONFIG_OPTS\"" > config_opts.sh
729 chmod +x config_opts.sh
730 echo "OPTSATBUILDTIME += $OPTS" > buildopts.mk
731 $MAKE $MAKEOPTS basics OPTS="$OPTS $BUILD_SHARED" QUIET="$QUIET"
732 MAKEEXIT=$?
733 [ $MAKEEXIT -ne 0 ] && printError
735 Echo "Performing '$MAKE $MAKEOPTS $PROGRAM OPTS="$OPTS" QUIET="$QUIET"' in $DESTINATION/tmp"
736 $MAKE $MAKEOPTS $PROGRAM OPTS="$OPTS $BUILD_SHARED" QUIET="$QUIET"
737 MAKEEXIT=$?
738 if [ $MAKEEXIT -eq 0 ]
739 then
740 Echo "-------------------------------------------------"
741 Echo "$PROGRAM built successfully."
742 Echo "Next, try out a sample program like" \
743 "$DESTINATION/tests/charm++/simplearrayhello"
744 else
745 printError